// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef ConstantVectorSlotValue_h_included
#include "ConstantVectorSlotValue.h"
#endif

#ifndef Dynavec_h_included
#include "Dynavec.h"
#endif

#ifndef SP_h_included
#include "SP.h"
#endif

#ifndef SlotValue_h_included
#include "SlotValue.h"
#endif

#ifndef MemoryUtil_h_included
#include "MemoryUtil.h"
#endif


#ifndef IntSlotValue_h_included
#include "IntSlotValue.h"
#endif

ConstantVectorSlotValue::ConstantVectorSlotValue
(const Dynavec <SP <SlotValue> > &values)
  // We need a copyable value in the "default value" slot, but it doesn't
  // matter much what we use. 
  : VectorSlotValue (values.size()>0?&*values[0]:NEW (IntSlotValue (0)),
		     values, true)
{}

bool ConstantVectorSlotValue::hasTheSameTypeAs (const SlotValue *s) const {
  return 0 != dynamic_cast <const ConstantVectorSlotValue *> (s);
}

SP<SlotValue> ConstantVectorSlotValue::copy () const {
  // The default copy constructor is fine here.
  return NEW (ConstantVectorSlotValue (*this));
}


