// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef CursorBallActionConfiguration_h_included
#define CursorBallActionConfiguration_h_included

#ifndef OuterTransformConfiguration_h_included
#include "OuterTransformConfiguration.h"
#endif

class CursorBallActionConfiguration
// This presents a configuration for the user to edit with a slot that is the
// cursorball managed by the CursorBallManger.  We don't bother providing a
// programmatic interface to manipulate that slot; instead, methods should just
// call the appropriate method on the CursorBallManager directly.
  : public OuterTransformConfiguration
{
public:
  CursorBallActionConfiguration ();
  bool hasTheSameTypeAs (const Configuration *c) const;
  SP<Configuration> copy () const;
  virtual SP<SlotValue> getSlot (const FString &name);
  virtual SP<const SlotValue> getSlot (const FString &name) const;
  virtual SP<BadSlotValue> setSlot (const FString &name, SP<SlotValue> sv);
};

#endif
