// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//
#ifndef TypedFactory_h_included
#include "TypedFactory.h"
#endif

#ifndef SP_h_included
#include "SP.h"
#endif

#ifndef MemoryUtil_h_included
#include "MemoryUtil.h"
#endif

#ifndef Action_h_included
#include "Action.h"
#endif

#ifndef FactoryTable_h_included
#include "FactoryTable.h"
#endif

#ifndef FString_h_included
#include "FString.h"
#endif

#ifndef MouseDragConfiguration_h_included
#include "MouseDragConfiguration.h"
#endif

namespace {
  // A MouseDrag that does nothing.  Good for a default value in a mouse drag
  // binding. 
  class NullMouseDrag
    : public TypedFactory <MouseDragConfiguration, Action>
  {
  public:
    NullMouseDrag ()
      : TypedFactory <MouseDragConfiguration, Action> ("NullMouseDrag")
    {}
    SP<MouseDragConfiguration> typedDefaultConfiguration () const {
      return NEW (MouseDragConfiguration ());
    }
    SP<Action> makeIt (MouseDragConfiguration *conf) const {
      (void) conf;
      return NEW (Action ());
    }
  };
  const bool useless =
  (FactoryTable::store ("MouseDrag", NEW (NullMouseDrag ())), false);
}; // namespace
