#ifndef SceneGraphPOInterface_h_included
#define SceneGraphPOInterface_h_included

// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

// SceneGraph's have to implement this abstract base class if they want to call
// the PhysicsObject doPhysics method that does objects in batches.  This is a
// separate class from SceneGraph to let the compiler enforce the constraint
// that the SceneGraph doesn't have to be prepared to report links or neighbors
// to anybody but that doPhysics method.
#ifndef SP_h_included
#include "SP.h"
#endif

#ifndef PhysicsObjectInfo_h_included
#include "PhysicsObjectInfo.h"
#endif

#ifndef SceneGraph_h_included
#include "SceneGraph.h"
#endif

#ifndef LinkManager_h_included
#include "LinkManager.h"
#endif

#ifndef Dynavec_h_included
#include "Dynavec.h"
#endif

class SceneGraphPOInterface : public SceneGraph
{
public:
  SceneGraphPOInterface (SP<LinkManager> lm) : SceneGraph (lm) {};
  virtual const Dynavec<PhysicsObjectInfo> &neighbors (int objectIndex) const
    = 0;
  virtual const Dynavec<PhysicsObjectInfo> &links (int objectIndex) const = 0;
};
#endif
