// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef AnyOrbMove_h_included
#define AnyOrbMove_h_included

#ifndef TypedFactory_h_included
#include "TypedFactory.h"
#endif

#ifndef CursorBallActionConfiguration_h_included
#include "CursorBallActionConfiguration.h"
#endif

#ifndef Action_h_included
#include "Action.h"
#endif

class RecursiveSlotValue;
// Transform something based on Space Orb motion. 
class AnyOrbMove
  : public TypedFactory <CursorBallActionConfiguration, Action>
{
public:
  AnyOrbMove ();
  SP<CursorBallActionConfiguration> typedDefaultConfiguration () const;
  FString getPrettyName (const Configuration *c) const;
  SP<Action> makeIt (CursorBallActionConfiguration *cbac) const;
  // Given a value for the transformAction slot, return a RSV that is an
  // AnyOrbMove with that value for the slot.
  static SP<RecursiveSlotValue> mkOrbMove (RecursiveSlotValue *slot);
  // Likewise, except look the name up in the TransformAction protocol.
  static SP<RecursiveSlotValue> mkOrbMove (const FString &name);
};

#endif
