// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@fungible.com, or by
// paper mail at:
//
// Tim Freeman
// 381 North Fernwood Circle
// Sunnyvale, CA 94085-3059
//

#ifndef OuterTransformConfiguration_h_included
#define OuterTransformConfiguration_h_included

#ifndef SP_h_included
#include "SP.h"
#endif

#ifndef SimpleGrabbingActionConfiguration_h_included
#include "SimpleGrabbingActionConfiguration.h"
#endif

class Configuration;
class Action;
class TransformConfiguration;
class RecursiveSlotValue;
class OuterTransformConfiguration
// A configuration for an action that wraps around a TransformAction.
  : public SimpleGrabbingActionConfiguration
{
public:
  OuterTransformConfiguration ();
  bool hasTheSameTypeAs (const Configuration *c) const;
  SP<Configuration> copy () const;
  SP<RecursiveSlotValue> getTransformAction ();
  SP<const RecursiveSlotValue> getTransformAction () const;
  void setTransformAction (SP<RecursiveSlotValue>);
};
#endif
