#ifndef State_h_included
#include "State.h"
#endif

#ifndef MemoryUtil_h_included
#include "MemoryUtil.h"
#endif

#ifndef myassert_h_included
#include "myassert.h"
#endif

#ifndef NEIGHBORSTATE_h_included
#include "NeighborState.h"
#endif

void State::setRange (int start, int end) {
  firstIndex = start;
  pastLastIndex = end;
  if (forceMiddle) {
    delete [] forceMiddle;
    assert (prevAtomMiddle);
    delete [] prevAtomMiddle;
  }
  forceMiddle = NEW (vector [end - start]);
  forceStart = forceMiddle - start;
  prevAtomMiddle = NEW (vector [end - start]);
  prevAtomStart = prevAtomMiddle - start;
}

State::State () {
  // Fungimol's Float is the size of the integration variables.  In brennerc,
  // Double is the size of the integration variables like position.  Thus, we
  // need Float to mean Double until Fungimol makes the right distinction
  // between double's and float's.
  assert (sizeof (Float) == sizeof (Double));
  forceMiddle = 0;
  m_caNeighbors = newNeighborState ();
  m_ljNeighbors = newNeighborState ();
}

State::~State () {
  if (0 != forceMiddle) {
    delete [] forceMiddle;
    forceMiddle = 0;
    assert (prevAtomMiddle);
    delete [] prevAtomMiddle;
  }
  deallocateNeighborState (m_caNeighbors);
  deallocateNeighborState (m_ljNeighbors);
}
