/* kt.c - Copyright (c) 1998 Zyvex LLC.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#include "kt.h"

#ifndef BRENNER_h_included
#include "brenner.h"
#endif

int ktmax;
int kt[MAX_ATOMNO+1];
int kt2[NTYPES+1];

void static_initkt () {
  int i;
  for(i = 0; i <= NTYPES; ++i) {
    kt2[i] = 0;
  }
  for (i = 0; i <= MAX_ATOMNO; i++) {
    kt[i] = 0;
  }
  kt[HYDROGEN] = 2;
  kt[CARBON] = 1;
  /* The next two used to write to kt out of bounds, back before I made it have
     the size MAX_ATOMNO+1 instead of NTYPES+1.  Tim Freeman  5 Oct 2000. */
  kt[SILICON] = 3;
  kt[GERMANIUM] = 4;
  kt2[2] = HYDROGEN;
  kt2[1] = CARBON;
  kt2[3] = SILICON;
  kt2[4] = GERMANIUM;
  ktmax = 4;
}
